#pragma once

#include <istream>
#include <memory>

#include <QString>

class ClientAccess {
	ClientAccess();
public:
	ClientAccess(const QString& token, uint16_t port);
	static std::shared_ptr<ClientAccess> find();

public:
	QString getBasicAuth() const;
	uint16_t getPort() const;

	QString getURL() const;

private:

	QString authcode;
	uint16_t port = 0;
};

std::shared_ptr<ClientAccess> createFromLockfile(std::istream& lockfile);
