#pragma once

#include <QDialog>

namespace Ui {
	class ClipboardPopup;
}

class ClipboardPopup : public QDialog {
	Q_OBJECT

public:
	enum class Direction {
		Paste,
		Copy
	};

	explicit ClipboardPopup(Direction dir, QWidget* parent = nullptr);
	~ClipboardPopup();

	void setText(QString text);
	QString getText() const;

private slots:
	void textPasted();
	void copyButton();

private:
	Ui::ClipboardPopup *ui;

	Direction direction;
	int lastKnownTextSize = 0;
};
