#pragma once

#include <QWidget>

#include "runeaspekt.h"
#include "runepage.h"
#include "runestyle.h"

namespace Ui {
	class RuneDisplay;
}

class RuneDisplay : public QWidget {
	Q_OBJECT

public:
	explicit RuneDisplay(QWidget *parent = nullptr);
	~RuneDisplay();

	void setRuneMeta(const std::vector<RuneAspekt>& runeinfo);
	void setStyles(const std::vector<RuneStyle>& styleinfos);
	void setRunes(const RunePage& rp);

private slots:
	void applyRunesClicked();

signals:
	void applyRunes();

private:
	void updateText();
	QString getRuneText(uint32_t id);
	QString getRuneStyleByID(uint32_t id);

	Ui::RuneDisplay *ui;

	RunePage runepage;

	std::vector<RuneAspekt> runeinfo;
	std::vector<RuneStyle> runestyles;

};
