#pragma once

#include <memory>

#include <QWidget>

#include "config.h"
#include "runeaspekt.h"
#include "runestyle.h"

namespace Ui {
	class RuneManager;
}

class ClientAPI;
class DataDragon;
class QListWidgetItem;
class QTimer;

class RuneManager : public QWidget {
	Q_OBJECT

public:
	explicit RuneManager(QWidget* parent = nullptr);
	~RuneManager();

	void setConfig(Config& config);
	void setDataDragon(DataDragon& dd);

private slots:
	void loadRunes();
	void setRunesEnabled(bool enabled);

	void saveRunePageClient(int id, QString name, const RunePage& rp);
	void saveRunePageAA(int id, QString name, const RunePage& rp);

	void deleteRunepageClient(int id);
	void deleteRunepageAA(int id);

	void autoSyncToggled();

private:
	void syncRunes();
	void reloadAARunes();

	Ui::RuneManager* ui;
	std::shared_ptr<ClientAPI> client;
	Config* config = nullptr;
	QTimer* initialLoadTimer = nullptr;

	std::vector<RuneAspekt> runeInfo;
	std::vector<RuneStyle> runeStyles;
};
