#pragma once

#include <cstdint>
#include <ostream>
#include <vector>

#include <QDebug>
#include <QJsonObject>
// represents a runepage
struct RunePage {
public:
	uint32_t primaryStyle = 0;
	uint32_t secondaryStyle = 0;
	std::vector<uint32_t> selectedAspects; // all selected aspekts (should be exactly 9)

	RunePage();
	bool operator==(const RunePage& rp) const;

	operator bool() const; // check if this runepage is valid (this does not check semantic validity, only if the values are set as they supposed to be)

	operator QJsonObject() const;
	RunePage(const QJsonObject& obj);
};

std::ostream& operator<<(std::ostream&, const RunePage&);
QDebug operator<<(QDebug, const RunePage&);
