#include "files.h"

#include <sys/stat.h>

#include <QDir>

#include <Log.h>

#ifdef WIN32
#define CACHEPATH "lolautoacceptor/cache/"
#else
#define CACHEPATH ".cache/lolautoaccept/"
#endif

#ifdef WIN32

QString getHome() {
	const char* homevar = getenv("appdata");
	if(homevar == nullptr) {
		qWarning() << "%appdata% is not set! Defaulting to ./";
		return  "./";
	}
	return QString(homevar) + "/";
}
#else

QString getHome() {
	const char* homevar = getenv("HOME");
	if(homevar == nullptr) {
		qWarning() << "$HOME is not set! Defaulting to ./";
		return  "./";
	}
	return QString(homevar) + "/";
}
#endif

bool mkdirs(const QString& path) {
	return QDir::root().mkpath(path);
}

QString getCache() {
	return getHome() + CACHEPATH;
}
