#include "loadingwindow.h"
#include "ui_loadingwindow.h"

LoadingWindow::LoadingWindow(QWidget* parent) : QWidget(parent), ui(new Ui::LoadingWindow) {
	ui->setupUi(this);
}

LoadingWindow::~LoadingWindow() {
	delete ui;
}

void LoadingWindow::setChampion(QString championName) {
	this->setText(LoadingWindow::tr("Loading Champion: %0").arg(championName));
}

void LoadingWindow::setText(QString text) {
	ui->label->setText(text);
}

void LoadingWindow::setProgress(float val) {
	ui->progressBar->setValue(val * 100);
}

void LoadingWindow::closeEvent(QCloseEvent* event) {
	QWidget::closeEvent(event);
	emit this->closed();
}
