#include <thread>

#include <limits.h>

#include <QApplication>
#include <QFile>
#include <QMessageBox>
#include <QTranslator>

#include <Log.h>
#include <QDebug>

#include "arg.h"
#include "clientaccess.h"
#include "clientapi.h"
#include "mainwindow.h"

int main(int argc, char** argv) {
	Log::init();
	Log::setConsoleLogLevel(Log::Level::info);
#if __unix__
	Log::setColoredOutput(true);
#endif

	Args args = parseArgs(argc, argv);
	if(args.debugLog) {
		Log::setConsoleLogLevel(Log::Level::trace);
		Log::addLogfile("log.txt", Log::Level::trace);
		qDebug() << "debug Log enabled";
	}

	qInfo() << "Hello, World!";
	qInfo() << "Using Locale: " << QLocale().name();

	QApplication app(argc, argv);
	QTranslator translator;
	if(translator.load(QLocale().name(), ":/i18n")) {
		app.installTranslator(&translator);
	} else {
		qWarning() << "translation not found";
	}
	MainWindow win;

	int ret = app.exec();

	Log::stop();
	return ret;
}
